<template>
  <div class="md-layout">
    <div class="main-inner-width">
      <img src="../../assets/images/top-page-image-1.png" />
    </div>

    <article class="about-top-intro">
      <div class="about-top-intro__inner l-base">
        <img
          src="../../assets/images/logo-large.png"
          alt="JOLLYGOOD+"
          class="about-top-intro__logo"
        />
        <div class="about-top-intro__box">
          <p class="c-text about-top-intro__pre">
            全国の医療福祉機関250以上で導入
          </p>
          <h2 class="about-top-intro__h1">
            300以上の豊富なVR教材を<br />定額で利用し放題！！
          </h2>
          <p class="c-txt about-top-intro__txt pc">
            チーム医療、タスク・シフティング／シェアリング、<br />
            地域包括ケアシステム、医療福祉連携など、<br />
            医療福祉を取り巻く環境は大きく変化し、<br />
            あらゆる面で多角化が求められています。<br />
            JOLLYGOOD＋は医療福祉事業を展開する法人・従事者に、<br />
            今、求められている、多様な「プラス」を提供する、<br />
            VR総合プラットフォームです。
          </p>
          <a href="/about" class="c-link about-top-intro__link">
            <button class="c-gradient-blue top-page-btn-lg">
              JOLLYGOOD+の詳細を見る
            </button>
          </a>
        </div>
      </div>
      <figure class="about-top-intro__thumb">
        <picture>
          <source
            media="(max-width: 767px)"
            srcset="../../assets/images/intro-thumb-sp.png"
          />
          <img src="../../assets/images/intro-thumb-pc.png" alt="" />
        </picture>
      </figure>
    </article>
  </div>
</template>

<script>
import $ from 'jquery';
import 'slick-carousel';
import { mapActions } from 'vuex';
import arrowRightImage from '../../assets/images/arrow_right.png';
import arrowLeftImage from '../../assets/images/arrow_left.png';

export default {
  data() {
    return {
      curriculums: [],
      features: [],
      scenarioListsForTagSearch: [],
      scenarioListsAll: [],
      allScenarioListsVisible: true,
      selectedCategory: '',
      selectedTag: '',
    };
  },
  mounted() {
    // トップページ用の諸々を取得する
    this.fetchLibrariesTop()
      .then((e) => {
        this.curriculums = e.data.curriculums;
        this.features = e.data.features;
        this.scenarioListsForTagSearch = e.data.scenario_lists_for_tag_search;
        this.scenarioListsAll = e.data.scenario_lists;

        // 全てのAPIレスポンス帰ってきてからSliderの初期化をする必要あり
        this.$nextTick(() => {
          this.setSliderClass();
        });
      })
      .catch((e) => {
        // none
      });
  },
  computed: {
    removedZeroScenarioCurriculums: function () {
      return this.curriculums.filter((item) => item.scenarios.length != 0);
    },
    removedZeroScenarioFeatures: function () {
      return this.features.filter((item) => item.scenarios.length != 0);
    },
  },
  methods: {
    ...mapActions(['fetchLibrariesTop']),

    // カリキュラムのシナリオを2要素ずつ配列にする
    groupingCurriculumScenarios: function (curriculum) {
      const base = curriculum.scenarios.length;
      const split_cnt = 2; // 何個ずつに分割するか
      const grouped_array = [];
      for (let i = 0; i < Math.ceil(base / split_cnt); i++) {
        let multiple_cnt = i * split_cnt; // 2の倍数
        // (i * 2)番目から(i * 2 + 2)番目まで取得
        let result = curriculum.scenarios.slice(
          multiple_cnt,
          multiple_cnt + split_cnt
        );
        grouped_array.push(result);
      }
      return grouped_array;
    },
    setSliderClass: function () {
      $(function () {
        $('.pc-tab').find('.tab li').first().addClass('active');
        $('.pc-tab').find('.tab-target').first().addClass('active');
        $('.sp-tab').find('.tab li').first().addClass('active');
        $('.sp-tab').find('.tab-target').first().addClass('active');

        $('.slider').slick({
          arrows: true,
          autoplay: false,
          adaptiveHeight: false,
          slidesToShow: 4,
          slidesToScroll: 1,
          centerMode: false,
          variableWidth: false,
          infinite: false,
          nextArrow:
            '<img src="' + arrowRightImage + '" class="slide-arrow nextArrow">',
          prevArrow:
            '<img src="' + arrowLeftImage + '" class="slide-arrow prevArrow">',
          responsive: [
            {
              breakpoint: 768,
              settings: {
                infinite: false,
                variableWidth: false,
                arrows: false,
                slidesToShow: 2,
                slidesToScroll: 2,
                centerMode: false,
              },
            },
          ],
        });

        /* PC用 */
        $('.slider-tab-pc').slick({
          arrows: true,
          autoplay: false,
          slidesToShow: 3,
          slidesToScroll: 1,
          centerMode: false,
          variableWidth: true,
          infinite: false,
          nextArrow:
            '<img src="' + arrowRightImage + '" class="slide-arrow nextArrow">',
          prevArrow:
            '<img src="' + arrowLeftImage + '" class="slide-arrow prevArrow">',
        });

        /* スマホ用 */
        $('.slider-tab-sp').slick({
          arrows: false,
          autoplay: false,
          slidesToShow: 2,
          slidesToScroll: 2,
          centerMode: false,
          variableWidth: false,
          infinite: false,
          nextArrow:
            '<img src="' + arrowRightImage + '" class="slide-arrow nextArrow">',
          prevArrow:
            '<img src="' + arrowLeftImage + '" class="slide-arrow prevArrow">',
        });

        $('.pc-tab .tab').on('click', 'li', function () {
          let index = $('.pc-tab').find('.tab li').index(this);
          if (!$(this).hasClass('active')) {
            $('.pc-tab .tab li').removeClass('active');
            $(this).addClass('active');
            $('.pc-tab').find('.tab-target').removeClass('active');
            $('.pc-tab').find('.tab-target').eq(index).addClass('active');

            $('.pc-tab')
              .find('.tab-target')
              .eq(index)
              .find('.slider-tab-pc')
              .slick('setPosition');
          }
        });

        $('.sp-tab .tab').on('click', 'li', function () {
          let index = $('.sp-tab').find('.tab li').index(this);
          if (!$(this).hasClass('active')) {
            $('.sp-tab .tab li').removeClass('active');
            $(this).addClass('active');
            $('.sp-tab').find('.tab-target').removeClass('active');
            $('.sp-tab').find('.tab-target').eq(index).addClass('active');

            $('.sp-tab')
              .find('.tab-target')
              .eq(index)
              .find('.slider-tab-sp')
              .slick('setPosition');
          }
        });
      });
    },
    limitScenarioNameLengthPC: function (name) {
      return name.length >= 31 ? name.substr(0, 29) + '...' : name;
    },
    limitScenarioNameLengthSP: function (name) {
      return name.length >= 28 ? name.substr(0, 26) + '...' : name;
    },

    showScenarioListsAll: function () {
      this.clearSelectedCategory();
      this.clearSelectedTag();
      this.allScenarioListsVisible = true;
    },

    setSelectedCategory: function (category) {
      this.allScenarioListsVisible = false;
      this.clearSelectedTag();
      this.selectedCategory = category;
    },

    setSelectedTag: function (tag) {
      this.allScenarioListsVisible = false;
      this.clearSelectedCategory();
      this.selectedTag = tag;
    },

    clearSelectedCategory: function () {
      this.selectedCategory = '';
    },

    clearSelectedTag: function () {
      this.selectedTag = '';
    },
  },
};
</script>

<style lang="scss" scoped>
@import url('/src/packs/home_overrides.css');
</style>
